#include "convol.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "matrix.h"

void convol(int w, int h, uint8_t* s, const uint8_t* a, matrix_t* mat)
{
  static int kk=0;
  int i, j, k, l, n=mat->w;
  for(i=0; i<h; i++)
  {
    for(j=0; j<w; j++)
    {
      int aa =0, bb=0, cc=0;
      
      for(k=-n/2; k<n/2+1; k++)
      {
        if(i+k<0 || i+k>=h) continue;
        for(l=-n/2; l<n/2+1; l++)
        {
          int m;
          if(j+l<0 || j+l>=w) continue;
          m=mat->mat[(n/2+k)*n+n/2+l];
          aa+=a[((i+k)*w+j+l)*3]*m;
          bb+=a[((i+k)*w+j+l)*3+1]*m;
          cc+=a[((i+k)*w+j+l)*3+2]*m;
          
        }
      }
      if(1)
      {
        s[(i*w+j)*3]=aa;
        s[(i*w+j)*3+1]=bb;
        s[(i*w+j)*3+2]=cc;
      }else{
        s[(i*w+j)*3]=aa/n/n;
        s[(i*w+j)*3+1]=bb/n/n;
        s[(i*w+j)*3+2]=cc/n/n;
      }
    }
  }
  kk++;
}

void convol_monochrome(int w, int h, uint8_t* s, const uint8_t* a, matrix_t* mat)
{
  static int kk=0;
  int i, j, k, l, n=mat->w;
  for(i=0; i<h; i++)
  {
    for(j=0; j<w; j++)
    {
      int aa =0, bb=0, cc=0, dd;
      
      for(k=-n/2; k<n/2+1; k++)
      {
        if(i+k<0 || i+k>=h) continue;
        for(l=-n/2; l<n/2+1; l++)
        {
          int m;
          if(j+l<0 || j+l>=w) continue;
          m=mat->mat[(n/2+k)*n+n/2+l];
          aa+=a[((i+k)*w+j+l)*3]*m;
          bb+=a[((i+k)*w+j+l)*3+1]*m;
          cc+=a[((i+k)*w+j+l)*3+2]*m;
          
        }
      }
      if(1)
      {
        dd=(aa+bb+cc)/n/n/3;
        s[(i*w+j)*3]=s[(i*w+j)*3+1]=s[(i*w+j)*3+2]=dd;
      }else{
        s[(i*w+j)*3]=aa/n/n;
        s[(i*w+j)*3+1]=bb/n/n;
        s[(i*w+j)*3+2]=cc/n/n;
      }
    }
  }
  kk++;
}
