#include "image.h"



pixel_t* pixel_set(pixel_t* p, uint8_t r, uint8_t g, uint8_t b)
{
	p->r=r;
	p->g=g;
	p->b=b;
	return p;
}

image_t* image_set(image_t* p, int w, int h, pixel_t* data)
{
	if(!p)
	{
		p=malloc(sizeof(image_t));
		p->isstatic=0;
	}else p->isstatic=1;
	p->w=w;
	p->h=h;
	p->mat=(pixel_t*)data;
	p->isallocated=0;
	return p;
}

image_t* image_clear(image_t* p)
{
	memset(p->mat, 0, p->w*p->h*sizeof(pixel_t));
}

image_t* image_copy(image_t* p, int w, int h, pixel_t* data)
{
	if(!p)
	{
		p=malloc(sizeof(image_t));
		p->isstatic=0;
	}else p->isstatic=1;
	p->w=w;
	p->h=h;
	p->mat=malloc(sizeof(pixel_t)*w*h);
	memcpy(p->mat, data, sizeof(pixel_t)*w*h);
	p->isallocated=1;
	return p;
}


image_t* image_mem_copy(image_t* out, const image_t* in)
{
	if(out->w>=in->w && out->h>=in->h)
	{
		memset(out->mat, in->mat, in->w*in->h*sizeof(image_t));
	}
	return out;
}


image_t* image_empty(image_t* p, int w, int h)
{
	if(!p)
	{
		p=malloc(sizeof(image_t));
		p->isstatic=0;
	}else p->isstatic=1;
	p->w=w;
	p->h=h;
	p->mat=malloc(sizeof(pixel_t)*w*h);
	memset(p->mat, 0, sizeof(pixel_t)*w*h);
	p->isallocated=1;
	return p;
}


void image_free(image_t* p)
{
	if(p->isallocated) free(p->mat);
	if(p->isstatic) free(p);
}
