#include "matrix.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>

matrix_t* 	matrix_3_3_init	 (matrix_t* m, float a, float b, float c,
														  float d, float e, float f,
															float g, float h, float i)
{
	if(!m)
	{
		m=malloc(sizeof(matrix_t));
		if(!m) return NULL;
		m->isstatic=0;
	}else m->isstatic=1;
	m->w=m->h=3;
	m->mat[0]=a;
	m->mat[1]=b;
	m->mat[2]=c;
	m->mat[3]=d;
	m->mat[4]=e;
	m->mat[5]=f;
	m->mat[6]=g;
	m->mat[7]=h;
	m->mat[8]=i;
	return m;
}

matrix_t*		matrix_init				(matrix_t* m, int width)
{
	if(!m)
	{
		m=malloc(sizeof(matrix_t));
		if(!m) return NULL;
		m->isstatic=0;
	}else m->isstatic=1;
	m->w=width;
	m->h=0;
	return m;
}


matrix_t*		matrix_init_array (matrix_t* m, int width, int height, const float* data)
{
	if(!m)
	{
		m=malloc(sizeof(matrix_t));
		if(!m) return NULL;
		m->isstatic=0;
	}else m->isstatic=1;
	m->w=width;
	m->h=height;
	memcpy(m->mat, data, width*height*sizeof(float));
	return m;
}

void	matrix_insert_row3(matrix_t* m, float a, float b, float c)
{
	int start=m->w*m->h;
	if(m->w!=3) return;
	m->mat[start]=a;
	m->mat[start+1]=b;
	m->mat[start+2]=c;
	m->h++;
}

void 	matrix_insert_row5(matrix_t* m, float a, float b, float c, float d, float e)
{
	int start=m->w*m->h;
	if(m->w!=5) return;
	m->mat[start]=a;
	m->mat[start+1]=b;
	m->mat[start+2]=c;
	m->mat[start+3]=d;
	m->mat[start+4]=e;
	m->h++;
}

void 	matrix_insert_row7(matrix_t* m, float a, float b, float c, float d, float e, float f, float g)
{
	int start=m->w*m->h;
	if(m->w!=7) return;
	m->mat[start]=a;
	m->mat[start+1]=b;
	m->mat[start+2]=c;
	m->mat[start+3]=d;
	m->mat[start+4]=e;
	m->mat[start+5]=f;
	m->mat[start+6]=g;
	m->h++;
}

void	matrix_delete			(matrix_t* m)
{
	if(!m->isstatic)
	{
		free(m);
	}
}


float matrix_get(matrix_t* m, int w, int h)
{
	return m->mat[h*m->w+w];
}
