#ifndef MATRIX_H
#define MATRIX_H

typedef struct matrix_t matrix_t;

struct matrix_t
{
	int w;
	int h;
	float mat[81];
	int isstatic;
};

matrix_t* 	matrix_3_3_init	 (matrix_t* m, float a, float b, float c,
														  float d, float e, float f,
															float g, float h, float i);

matrix_t*		matrix_init				(matrix_t* m, int width);

matrix_t*		matrix_init_array (matrix_t* m, int width, int height, const float* data);

void 				matrix_insert_row3(matrix_t* m, float a, float b, float c);
void			 	matrix_insert_row5(matrix_t* m, float a, float b, float c, float d, float e);
void			 	matrix_insert_row7(matrix_t* m, float a, float b, float c, float d, float e, float f, float g);
void				matrix_delete			(matrix_t* m);
float 			matrix_get				(matrix_t* m, int w, int h);
#endif
