#include "main.h"
#include "paint.h"
#include "image.h"
#include <math.h>


void draw_circle(image_t* img, point_t a, int r, pixel_t c)
{
	int x,y;
	float alpha;
	for(alpha=0.0; alpha<2*3.14159; alpha+=0.01)
	{
		x=cos(alpha)*r+a.x;
		y=sin(alpha)*r+a.y;
		if(x<img->w && y<img->h && x>=0 && y>=0) IMG_SET(img,x,y,c);
	}
}

void fill_circle(image_t* img, point_t a, int r, pixel_t c)
{
	int x,y, i;
	float alpha;
	for(i=0; i<r; i++)
		for(alpha=0.0; alpha<2*3.14159; alpha+=0.1/r)
		{
			x=cos(alpha)*i+a.x;
			y=sin(alpha)*i+a.y;
			if(x<img->w && y<img->h && x>=0 && y>=0) IMG_SET(img,x,y,c);
		}
}


void draw_rect( image_t* img, point_t a, point_t b, pixel_t c)
{
	int i;
	for(i=a.x; i<=a.x+b.x; i++) 
	{
		
		if(i<img->w && a.y<img->h && i>=0 && a.y>=0) IMG_SET(img,i,a.y,c);
		if(i<img->w && b.y+a.y<img->h && i>=0 && b.y+a.y>=0) IMG_SET(img,i,b.y+a.y,c);
	}
	for(i=a.y; i<=a.y+b.y; i++) 
	{
		if(a.x<img->w && i<img->h && a.x>=0 && i>=0) IMG_SET(img,a.x,i,c);
		if(a.x+b.x<img->w && i<img->h && a.x+b.x>=0 && i>=0) IMG_SET(img,a.x+b.x,i,c);
	}
}

void fill_rect(image_t* img, point_t a, point_t b, pixel_t c)
{
	int i,j;
	for(i=a.x; i<=a.x+b.x; i++) 
	{
		for(j=a.y; j<a.y+b.y; j++)
		{
			if(i>=img->w || j>=img->h || i<0 || j<0) continue;
			IMG_SET(img,i,j,c);
		}
	}
}


void draw_line(image_t* img, point_t a, point_t b, pixel_t c)
{
	double dx = b.x;
	double dy = b.y;
	double err = 0;
	double derr =(dx==0)?0:dy/dx;
	if(derr<0) derr=-derr;
	int y = a.y;
	int x;
	//printf("%f = %f / %f\n", derr, dy, dx);
	for(x=a.x; x<a.x+b.x; x++)
	{
		if(x>=img->w || y>=img->h || x<0 || y<0) continue;
		IMG_SET(img, x, y, c);
		err+=derr;
		while(err>=0.5)
		{
			if(x>=img->w || y>=img->h || x<0 || y<0) break;
			IMG_SET(img, x, y, c);
			y+=(b.y<0)?-1:1;
			err-=1;
		}
	}

}
