#include "sdl.h"
#include <stdio.h>
#include <stdlib.h>
#include "image.h"




int sdl_init(sdl_t *sdl, int w, int h) 
{
	SDL_Init( SDL_INIT_EVERYTHING );
	atexit( SDL_Quit );
	sdl->width=w;
	sdl->height=h;
	sdl->window = SDL_CreateWindow
			(
			"SDL2",
			SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED,
			sdl->width, sdl->height,
			SDL_WINDOW_SHOWN
			);

	sdl->renderer = SDL_CreateRenderer
			(
			sdl->window,
			-1,
			SDL_RENDERER_ACCELERATED
			);


	sdl->texture = SDL_CreateTexture
			(
			sdl->renderer,
			SDL_PIXELFORMAT_RGB24,
			SDL_TEXTUREACCESS_TARGET,
			sdl->width, sdl->height
			);
	return 0;
}


int sdl_close(sdl_t* sdl)
{
	 SDL_DestroyRenderer( sdl->renderer );
   SDL_DestroyWindow( sdl->window );
   SDL_Quit();
   return 0;
}

int sdl_mainloop(sdl_t* sdl, sdl_mainloop_cb cb, void* data)
{
	SDL_Event event;
	time(NULL);
	int running = 1, x, state =0;
	image_t out;
	image_empty(&out, sdl->width, sdl->height);
	while( running )
	{

			
			SDL_RenderClear( sdl->renderer );
			
			while( SDL_PollEvent( &event ) )
			{
					if( ( SDL_QUIT == event.type ) ||
							( SDL_KEYDOWN == event.type && SDL_SCANCODE_ESCAPE == event.key.keysym.scancode ) )
					{
							running = 0;
							break;
					}
					else if( ( SDL_MOUSEBUTTONUP == event.type || SDL_MOUSEBUTTONDOWN == event.type ) )
					{
					    state=!state;
					    
					}
			}
			if(state) printf("%d,%d = r=%02x g=%02x b=%02x\n",event.button.x,event.button.y,	
							  IMG_GET_R(&out, event.button.x,event.button.y),
							  IMG_GET_G(&out, event.button.x,event.button.y),
							  IMG_GET_B(&out, event.button.x,event.button.y));
			x=cb(&out, data);
			sdl_setimage(sdl,(uint8_t*)out.mat);
			if(x) running=0;
	}
	return 0;
}


int sdl_setimage(sdl_t* sdl, const void* pixels)
{
	SDL_UpdateTexture
            (
            sdl->texture,
            NULL,
            pixels,
            sdl->width*3
            );
  
  SDL_RenderCopy( sdl->renderer, sdl->texture, NULL, NULL );
  SDL_RenderPresent( sdl->renderer );
  return 0;
}
