#ifndef SDL2_WRAPPER_H
#define SDL2_WRAPPER_H

#include <SDL2/SDL.h>
#include <SDL2/SDL_render.h>

struct image_t;

typedef struct sdl_t sdl_t;
struct sdl_t
{
  int width;
  int height;
  SDL_Window* window;
  SDL_Renderer* renderer;
  SDL_Texture* texture;
};


typedef int (*sdl_mainloop_cb)(struct image_t*, void*);

int sdl_init(sdl_t* sdl, int w, int h);
int sdl_close(sdl_t* sdl);
int sdl_mainloop(sdl_t* sdl, sdl_mainloop_cb cb, void* data);
int sdl_setimage(sdl_t* sdl, const void* pixels);
#endif
