#ifndef VD_H
#define VD_H

#include <linux/videodev2.h>
#include <libv4l2.h>
#include <sys/types.h>
#include <sys/time.h>
struct image_t;

#define CLEAR(x) memset(&(x), 0, sizeof(x))
typedef struct buffer buffer;
struct buffer {
        void   *start;
        size_t length;
};

typedef struct vd_t vd_t;
typedef int (*vd_cb)(vd_t*, struct image_t*, const struct image_t*);
struct vd_t 
{
  struct v4l2_format              fmt;
  struct v4l2_buffer              buf;
  struct v4l2_requestbuffers      req;
  enum v4l2_buf_type              type;
  fd_set                          fds;
  struct timeval                  tv;
  int                             fd;
  unsigned int                    n_buffers;
  char                            dev_name[256];
  char                            out_name[256];
  FILE                            *fout;
  struct buffer                   *buffers;
  void														*buffertmp;
  int 														width;
  int 														height;
  vd_cb														callback;
};



int							vd_init											( vd_t* v, const char* dev, int w, int h, vd_cb cb);
int							vd_close										(vd_t* v);
int							vd_shot											(vd_t* v);
int							vd_get_relative_buffer_index(vd_t *v, int offset);
struct image_t*	vd_get_image								(vd_t* v, struct image_t* im, int i);
struct image_t*	vd_image_current						(vd_t* v, struct image_t* im);
struct image_t*	vd_image_prev								(vd_t* v, struct image_t* im);
struct image_t*	vd_image_prev_prev					(vd_t* v, struct image_t* im);
int 						vd_callback									(struct image_t* out, void* data);

#endif
